/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 10 janvier 2007
   derniere modification le 09/03/2008 */

#include <SCE/SCEMinimal.h>

#include <SCE/core/SCECMatrix.h>


/* ajoute le 02/07/2007 */
/* revise le 09/03/2008 */
void SCE_CLoadIdentityMatrix (void)
{
    glLoadIdentity ();
}

/* revise le 09/03/2008 */
void SCE_CPushMatrix (void)
{
    glPushMatrix ();
}
/* revise le 09/03/2008 */
void SCE_CPopMatrix (void)
{
    glPopMatrix ();
}

/* revise le 09/03/2008 */
void SCE_CSetActiveMatrix (SCEenum matrix)
{
    glMatrixMode (matrix);
}
/* revise le 09/03/2008 */
int SCE_CGetActiveMatrix (void)
{
    int matrix;
    glGetIntegerv (GL_MATRIX_MODE, &matrix);
    return matrix;
}

/* revise le 09/03/2008 */
void SCE_CMultMatrix (const float *m)
{
    glMultTransposeMatrixf (m);
}
/* revise le 09/03/2008 */
void SCE_CLoadMatrix (const float *m)
{
    glLoadTransposeMatrixf (m);
}

/* revise le 09/03/2008 */
void SCE_CGetMatrix (int matrix, float *m)
{
    if (matrix == SCE_CURRENT_MATRIX)
        glGetIntegerv (GL_MATRIX_MODE, &matrix);
    switch (matrix)
    {
    case GL_MODELVIEW:  glGetFloatv (GL_TRANSPOSE_MODELVIEW_MATRIX,  m); break;
    case GL_PROJECTION: glGetFloatv (GL_TRANSPOSE_PROJECTION_MATRIX, m); break;
        /* TODO: et pour elle, on prend la transposee ?? */
    case GL_TEXTURE:    glGetFloatv (GL_TRANSPOSE_TEXTURE_MATRIX,    m);
    }
}

void SCE_CTranslateMatrix(float x, float y, float z)
{
    glTranslatef(x, y, z);
}

void SCE_CRotateMatrix(float angle, float x, float y, float z)
{
    glRotatef(angle, x, y, z);
}

void SCE_CScaleMatrix(float x, float y, float z)
{
    glScalef(x, y, z);
}


void SCE_CTranslateMatrixv(float *v)
{
    glTranslatef(v[0], v[1], v[2]);
}

void SCE_CRotateMatrixv(float angle, float *v)
{
    glRotatef(angle, v[0], v[1], v[2]);
}

void SCE_CScaleMatrixv(float *v)
{
    glScalef(v[0], v[1], v[2]);
}

#if 0
void SCE_CLook3D(
  float p0, float p1, float p2,
  float v0, float v1, float v2,
  float i0, float i1, float i2)
{
    gluLookAt(p0, p1, p2, v0, v1, v2, i0, i1, i2);
}
void SCE_CLook3Dv(const float *p, const float *v, const float *i)
{
    gluLookAt(p[0], p[1], p[2], v[0], v[1], v[2], i[0], i[1], i[2]);
}
#endif

void SCE_CSetFrustumMatrix (
  GLdouble left, GLdouble right,
  GLdouble bottom, GLdouble top,
  GLdouble near, GLdouble far)
{
    glFrustum (left, right, bottom, top, near, far);
}

void SCE_CSetOrthoMatrix (
  GLdouble left, GLdouble right,
  GLdouble bottom, GLdouble top,
  GLdouble near, GLdouble far)
{
    glOrtho (left, right, bottom, top, near, far);
}


void SCE_CViewport (int x, int y, int w, int h)
{
    glViewport (x, y, w, h);
}
